let rec list_split3 = function
   [] -> ([], [], [])
 | ((x, y, z)::l) -> let (l1, l2, l3) = list_split3 l in
                     (x::l1, y::l2, z::l3);;

let add x l =
 if List.mem x l then l else x::l;;

let union l1 l2 = List.fold_right add l1 l2;;
let unions l = List.fold_left union [] l;;

let rec remove1 x = function
   (y::r) when x = y -> r
 | (y::r) -> y::(remove1 x r)
 | [] -> failwith "remove1";;

let subset l1 l2 = List.for_all (fun x -> List.mem x l2) l1;;

exception Runtime of string;;

let runtime_msg s = raise (Runtime s);;

let comma_list def elem sep =
 let rec loop = function
    [] -> print_string def
  | [x] -> elem x
  | (x::r) -> elem x; print_string sep; loop r
 in loop;;
