open Common;;
open Types;;
open Term;;

type terr = typ_var list;;

let print_terr terr =
 print_string "["; comma_list "" print_typ_var "," (List.sort compare terr); print_string "]";;

type eq = typ * typ_var * typ * terr;;

let print_eq (tau, t, tau', terr) =
 begin match tau with
    TypVar _ -> print_typ tau
  | TypFun _ -> print_string "("; print_typ tau; print_string ")"
 end;
 print_string " -> "; print_typ_var t; print_string " = "; print_typ tau';
 print_string "   "; print_terr terr; print_newline ();;

let decomposible = function
   (_, _, TypFun _, _) -> true
 | _ -> false;;

let rec build_constr = function
   TypedTermId _ -> []
 | TypedTermAppl (tm, tn, t) -> build_constr tn @ build_constr tm @ [(get_type tn, t, get_type tm, fv_typed_term tn)]
 | TypedTermLambda (_, tm, _) -> build_constr tm
 | TypedTermForget (tm, tn, _) -> build_constr tm @ build_constr tn;;

type eq2 = typ2 * typ_var;;
