%{
open Term;;

let built_in = function
   "I" -> TermLambda ("x", TermId "x")
 | "D" -> TermLambda ("x", TermAppl (TermId "x", TermId "x"))
 | "F" -> TermLambda ("x", TermLambda ("y", TermId "y"))
 | "K" -> TermLambda ("x", TermLambda ("y", TermId "x"))
 | "S" -> TermLambda ("x", TermLambda ("y", TermLambda ("z",
           TermAppl (TermAppl (TermId "x", TermId "z"), TermAppl (TermId "y", TermId "z")))))
 | "@" -> TermLambda ("f", TermLambda ("x", TermAppl (TermId "f", TermId "x")))
 | "succ" -> TermLambda ("n", TermLambda ("f", TermLambda ("x",
	      TermAppl (TermId "f", TermAppl (TermAppl (TermId "n", TermId "f"), TermId "x")))))
 | "add" -> TermLambda ("m", TermLambda ("n", TermLambda ("g", TermLambda ("z",
 	     TermAppl (TermAppl (TermId "m", TermId "g"), TermAppl (TermAppl (TermId "n", TermId "g"), TermId "z"))))))
 | "mult" -> TermLambda ("m", TermLambda ("n", TermLambda ("g",
	      TermAppl (TermId "m", TermAppl (TermId "n", TermId "g")))))
 | "exp" -> TermLambda ("m", TermLambda ("n", TermAppl (TermId "n", TermId "m")))
 | "mkpair" -> TermLambda ("x", TermLambda ("y", TermLambda ("b",
	        TermAppl (TermAppl (TermId "b", TermId "x"), TermId "y"))))
 | "fst" -> TermLambda ("p", TermAppl (TermId "p", TermLambda ("x", TermLambda ("y", TermId "x"))))
 | "snd" -> TermLambda ("p", TermAppl (TermId "p", TermLambda ("x", TermLambda ("y", TermId "y"))))
 | x -> TermId x;;

let num_built_in n =
 let rec loop = function
    0 -> TermId "x"
  | n -> TermAppl (TermId "f", loop (n - 1))
 in
 TermLambda ("f", TermLambda ("x", loop n));;
%}

%token <string> ID
%token <int> NUM
%token LPAR RPAR LBRACK RBRACK BACK BREAK COMMA

%nonassoc FOO
%nonassoc BACK LPAR ID NUM LBRACK

%start instr
%type <Term.term> instr

%%

instr:
    appl BREAK                        { $1 }
;

appl:
    appl term                         { TermAppl ($1, $2) }
  | term                              { $1 }
;

term:
    BACK ID appl %prec FOO            { TermLambda ($2, $3) }
  | LPAR appl RPAR                    { $2 }
  | LBRACK appl COMMA appl RBRACK     { TermForget ($2, $4) }
  | ID                                { built_in $1 }
  | NUM                               { num_built_in $1 }
;
