open Types;;
open Equations;;
open Typing_tree;;

let proj_typ_var i x = x ^ "_" ^ string_of_int i;;

let proj_typ_vars i ts = List.map (proj_typ_var i) ts;;

let rec proj_typ i = function
   TypVar t -> TypVar (proj_typ_var i t)
 | TypFun (ts, tau) -> TypFun (proj_typ_vars i ts, proj_typ i tau);;

let rec proj_typ2 i = function
   TypVar2 t -> TypVar2 (proj_typ_var i t)
 | TypFun2 (taus, tau') -> TypFun2 (List.map (proj_typ2 i) taus, proj_typ2 i tau');;

let proj_terr = proj_typ_vars;;

let proj_eq i (tau, t, sigma, terr) =
 (proj_typ i tau, proj_typ_var i t, proj_typ i sigma, proj_terr i terr);;

let proj_typing_tree i = map_typing_tree (proj_typ2 i);;

let duplicate n fproj x =
 let rec loop i =
  if i > n
  then []
  else (fproj i x) :: (loop (i + 1))
 in loop 1;;
